/*----------------------------------------------------------------------------
 Copyright:      GNU
 Author:         MrTip
 Remarks:        
 known Problems: none
 Version:        2013.01.11
 Description:    LED Line Demontration
------------------------------------------------------------------------------*/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <stdlib.h>

#include "main.h"
#include "interrupts.h"

unsigned char LINE[16][3];			
unsigned char MBI_RAM[256];			
unsigned char colR;
unsigned char colG;
unsigned char colB;
int iR;
int iG;
int iB;
int kR;
int kG;
int kB;

int kS;
unsigned int iS;

unsigned int tRGBpos=0;				//pos of array
unsigned int tRGBstep=0;			//counter to 160

const int tRGB[58*3] PROGMEM = {
 1,	 1,	 1,
 1,	 1,	 1,
 0,	-1,	 0,
-1,	-1,	 0,
 1,	 1,	-1,
-1,	 1,	-1,
-1,	 0,	 0,
 0,	 0,	 0,
 1,	 0,	 0,
 1,	-1,	 0,
 0,	-1,	 0,
 0,	 0,	 1,
 0,	 0,	 1,
 0,	 1,	 0,
-1,	 1,	 0,
-1,	 0,	 0,
 0,	 0,	 0,
 1,	 0,	 0,
 1,	 0,	 0,
-1,	 0,	-1,
-1,	 0,	-1,
 1,	-1,	 1,
-1,	-1,	 1,
 0,	 1,	 0,
 0,	 1,	 0,
 0,	-1,	 0,
 1,	-1,	-1,
 1,	 0,	-1,
 0,	 0,	 0,
-1,	 1,	 0,
-1,	 1,	 0,
 0,	 0,	 0,
 0,	-1,	 1,
 0,	-1,	 1,
 0,	 0,	 0,
 0,	 0,	 0,
 1,	 1,	-1,
 1,	 1,	-1,
-1,	-1,	 1,
-1,	-1,	-1,
 1,	 0,	 0,
 1,	 1,	 0,
 0,	 1,	 0,
 0,	-1,	 0,
 0,	-1,	 1,
 0,	 0,	 1,
 0,	 0,	-1,
-1,	 0,	-1,
-1,	 0,	 0,
 0,	 1,	 0,
 0,	 1,	 1,
 0,	 0,	 1,
 0,	 0,	 0,
 0,	 0,	 0,
 0,	-1,	 0,
 0,	-1,	 0,
 0,  0,	-1,
 0,  0,	-1};


//--------------------------------------------------------------------------------------------------
unsigned char EEPROM_read(unsigned int uiAddress)
{
	while(EECR & (1<<EEWE));			/* Wait for completion of previous write */
	EEAR = uiAddress;					/* Set up address register */
	EECR |= (1<<EERE);					/* Start eeprom read by writing EERE */
	return EEDR;						/* Return data from data register */
}
//--------------------------------------------------------------------------------------------------
void EEPROM_write(unsigned int uiAddress, unsigned char ucData)
{
	while(EECR & (1<<EEWE));			/* Wait for completion of previous write */
	EEAR = uiAddress;					/* Set up address and data registers */
	EEDR = ucData;
	EECR |= (1<<EEMWE);					/* Write logical one to EEMWE */
	EECR |= (1<<EEWE);					/* Start eeprom write by setting EEWE */
}
//--------------------------------------------------------------------------------------------------
//void Init_Timer0(unsigned char width)
//{
//	TCCR0=5;	//div 1024
//	TIMSK=1;
//	TCNT0=(3579000/1024/174); //=3495	//20 per second
//	pulse=width&127;	
//}
//--------------------------------------------------------------------------------------------------
//ISR(TIMER0_OVF_vect)
//{
//	TCNT0=(3579000/1024/174); //=3495	//20 per second
//	if (pulsecnt==pulse) led0(0);
//	if (pulsecnt==0)     led0(1);
//	pulsecnt++;
//	pulsecnt &= 127;
//};	//	SIG_OVERFLOW0 			Timer/Counter0 Overflow
//--------------------------------------------------------------------------------------------------
ISR(INT1_vect)	//int 1/0 - falling //	SIG_INTERRUPT1			External Interrupt Request 1
{
//	ReceiveStatusPacket++;
};	
//--------------------------------------------------------------------------------------------------
void delay_us (unsigned int d) {
	unsigned int i;
	for (i=0;i<d;i++) 
	{
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");asm("nop");
	 }
}
//--------------------------------------------------------------------------------------------------
int main(void)
{	
	unsigned char s,i;
	unsigned char cnt;
	unsigned char rfcnt;
	unsigned char rx_char;
	unsigned char unknown_cmd;
	unsigned char cmd;			//zaraz po 
	unsigned int cnt_led;

	IO_Init();
	dR(0);
	dG(0);
	dB(0);
	sR(0);
	sG(0);

//	DDRB |= 44;
//	SPCR=(1<<SPE)|(1<<MSTR);
//	SPSR|=(1<<SPI2X);
//  while(1){led0(1);led1(0);_delay_ms(250);led0(0);led1(1);_delay_ms(250);}

//INT0_start
	MCUCR = (1<<ISC01)|(1<<ISC11);//2;	INT0 i INT1 falling
	GICR = (1<<6);//|(1<<7);	//INT0 , INT1 ON
	GIFR = 0;
//------------
	sei();
//------------
//	Init_Timer0(12);
	cnt_led=0;
//--------------------------------------------------------------------------------------------------
// MAINLOOP
//--------------------------------------------------------------------------------------------------
	dR_flash();
	colR=0;
	colG=0;
	colB=0;

	SendFrame();
	SendFrame();
	SendFrame();
	SendConfig();

	iR=0;
	iG=0;
	iB=0;

	tRGBpos=0;
	kR=pgm_read_word(&tRGB[(tRGBpos*3)+0]);
	kG=pgm_read_word(&tRGB[(tRGBpos*3)+1]);
	kB=pgm_read_word(&tRGB[(tRGBpos*3)+2]);


	iS=5000;
	kS=1;


	while(1)
	{
mainloop:
	delay_us(iS);
	
	iS=iS+kS;
	if (iS>10000) { iS=9999; kS=-1;}
	if (iS<5000) { iS=5001; kS=1;}


	SerialTestMBI();
	
	cnt_led++; 


/*
	if (iR>160) {iR=159; kR=-1; }
	if (iR<0) {iR=0; kR=0; kG=1; }

	if (iG>160) { iG=159; kG=-1; }
	if (iG<0) {iG=0; kG=0; kB=1; }

	if (iB>160) { iB=159; kB=-1; }
	if (iB<0) {iB=0; kB=0; kR=1; }
*/

	//is 40 steps tRGB one step is 160*40=6400
	tRGBstep++;
	if (tRGBstep==80)
		{
			tRGBstep=0;
			tRGBpos++; if (tRGBpos==58) { tRGBpos=0; iR=0; iG=0; iB=0; };
			kR=pgm_read_word(&tRGB[(tRGBpos*3)+0]);
			kG=pgm_read_word(&tRGB[(tRGBpos*3)+1]);
			kB=pgm_read_word(&tRGB[(tRGBpos*3)+2]);
		}

	iR=iR+kR;
	iG=iG+kG;
	iB=iB+kB;

	colR=iR/10;
	colG=iG/10;
	colB=iB/10;


	for (i=0;i<16;i++)
	{ 
		LINE[(i+cnt_led)&15][0]=i*colR;
		LINE[(i+cnt_led)&15][1]=i*colG; 
		LINE[(i+cnt_led)&15][2]=i*colB; 
	}
	MakeColor();
	SendFrame();

	sG(0); sR(0);


	} //while(1)
} //main

