
#ifndef _CLIENT_H
	#define _CLIENT_H

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/eeprom.h>
#include <util/delay.h>
#include <stdlib.h>


#define MBI_Count	3


#define LINIA 1

#ifdef LINIA

#define	_dR			0
#define	_dG			1
#define	_dB			2
#define	_sG			3
#define	_sR			4

#define	_DatIn		0
#define	_Dat		5
#define	_CLK		6
#define	_LE			7

#define	dR_PORT		PORTC
#define	dG_PORT		PORTC
#define	dB_PORT		PORTC
#define	sG_PORT		PORTC
#define	sR_PORT		PORTC

#define	DatIn_PORT	PORTB
#define	Dat_PORT	PORTD
#define	CLK_PORT	PORTD
#define	LE_PORT		PORTD

#define	dR_DDR		DDRC
#define	dG_DDR		DDRC
#define	dB_DDR		DDRC
#define	sG_DDR		DDRC
#define	sR_DDR		DDRC

#define	DatIn_DDR	DDRB
#define	DatIn_PIN	PINB
#define	Dat_DDR		DDRD
#define	CLK_DDR		DDRD
#define	LE_DDR		DDRD

#endif
// RS232  
#define	INT0_PORT			PORTD
#define	INT0_PIN			PIND
#define	INT0_DDR			DDRD
#define	rs_INT0				2	//PORTD.2
//-------

//----------------------------------------------------------------------------------------------------------------------------------
static inline void IO_Init(void)
{

	INT0_DDR  &= ~(1<<rs_INT0);  INT0_PORT  |=  (1<<rs_INT0);  //IN

	#ifdef LINIA
	dR_DDR |= (1<<_dR); dR_PORT |= (1<<_dR);
	dG_DDR |= (1<<_dG); dG_PORT |= (1<<_dG);
	dB_DDR |= (1<<_dB); dB_PORT |= (1<<_dB);
	sR_DDR |= (1<<_sR); sR_PORT |= (1<<_sR);
	sG_DDR |= (1<<_sG); sG_PORT |= (1<<_sG);

	Dat_DDR |= (1<<_Dat); Dat_PORT |= (1<<_Dat);
	CLK_DDR |= (1<<_CLK); CLK_PORT |= (1<<_CLK);
	LE_DDR  |= (1<<_LE);  LE_PORT  |= (1<<_LE);
	DatIn_DDR &= ~(1<<_DatIn); DatIn_PORT |= (1<<_DatIn);
	#endif

 
}
//----------------------------------------------------------------------------------------------------------------------------------

#ifdef LINIA

static inline void dR_flash(void)	{if(bit_is_set(dR_PORT, _dR)) { dR_PORT |= (1<<_dR);} else {dR_PORT &= ~(1<<_dR);}} 
static inline void dG_flash(void)	{if(bit_is_set(dG_PORT, _dG)) { dG_PORT |= (1<<_dG);} else {dG_PORT &= ~(1<<_dG);}} 
static inline void dB_flash(void)	{if(bit_is_set(dB_PORT, _dB)) { dB_PORT |= (1<<_dB);} else {dB_PORT &= ~(1<<_dB);}} 
static inline void sR_flash(void)	{if(bit_is_set(sR_PORT, _sR)) { sR_PORT |= (1<<_sR);} else {sR_PORT &= ~(1<<_sR);}} 
static inline void sG_flash(void)	{if(bit_is_set(sG_PORT, _sG)) { sG_PORT |= (1<<_sG);} else {sG_PORT &= ~(1<<_sG);}} 


static inline void dR(char state){ if (state==1) { dR_PORT |= (1<<_dR);} else { dR_PORT &= ~(1<<_dR);}}
static inline void dG(char state){ if (state==1) { dG_PORT |= (1<<_dG);} else { dG_PORT &= ~(1<<_dG);}}
static inline void dB(char state){ if (state==1) { dB_PORT |= (1<<_dB);} else { dB_PORT &= ~(1<<_dB);}}
static inline void sR(char state){ if (state==1) { sR_PORT |= (1<<_sR);} else { sR_PORT &= ~(1<<_sR);}}
static inline void sG(char state){ if (state==1) { sG_PORT |= (1<<_sG);} else { sG_PORT &= ~(1<<_sG);}}


inline void Dat(char state){ if (state==1) { Dat_PORT |= (1<<_Dat);} else { Dat_PORT &= ~(1<<_Dat);}}
inline void CLK(char state){ if (state==1) { CLK_PORT |= (1<<_CLK);} else { CLK_PORT &= ~(1<<_CLK);}}
inline void LE (char state){ if (state==1) { LE_PORT  |= (1<<_LE);}  else { LE_PORT &= ~(1<<_LE);}}


inline unsigned char DatIn(void) {return (DatIn_PIN&1);}//Input
#endif
//----------------------------------------------------------------------------------------------------------------------------------
unsigned char EEPROM_read(unsigned int uiAddress);
void EEPROM_write(unsigned int uiAddress, unsigned char ucData);


#endif
